/**
 * @(#)RisFrame.java
 * @author Claudia Rizzello
 * Classe della finestra relativa alla procedura con Risultato Immediato.
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import javax.swing.JTable.*;

public class RisFrame extends JFrame {
	private JPanel p;
	private JPanel p1;
	private JPanel p2;
	private JPanel p2_1;
	private JPanel p2_2;
	private JPanel p3;
	private JPanel p4;
	
	private JLabel titolo;
	private JLabel RefStlab;
	private JLabel pflab;
	
	private JTextField refSt;
	private JTextField pf;

	private JScrollPane psp;
	private DefaultTableModel model;
	private JTable mvtab;
	
	private JButton Esci;
	private JButton Start;
	
	//private int vittima;
	private int tp = 0;
	private int nframes;
	private int[] input;  
  	private TLB tlb;
  	private int nPageFault = 0;
  	private MemoriaVirtuale MV;
  	private int npagine;
  	private Page pcorrente;
  	private int indexVic = -1;	
  	private int pmax;	
  	private String mevi; 
  	private String stringa = "";	
	private String algoName = "";
	private int algoritmo;
	private int pagRef;
	private Object frameTab[][];
	private int[] sf; 
	private boolean again =	false;
	private int[] vittime;
	private DefaultTableCellRenderer mtr;
	private int firstLibero =1;
	private int dati[][];
	int vaso;
	String cn;
	String[] columnNames;
	int[] arrayMemo;


/**
 * Costruttore.
 *@param int[] ref, int nFrame, int alg, String alName 
 */
	public RisFrame(int[] ref, int nFrame, int alg, String alName) {
		
		mtr= new DefaultTableCellRenderer();
	   	input = new int[ref.length];
		input = ref;
		vittime = new int[ref.length];
		columnNames = new String[ref.length];
		nframes = nFrame;
		algoritmo = alg;
		algoName = alName;
		frameTab = new Object[nframes][ref.length];
		dati = new int[nframes][ref.length];
		sf = new int[nframes];
 	  	initAll();
		setSize(new Dimension(500, 400));
		Container cnt = getContentPane();
	
		p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.CENTER,6,6));
		p.setSize(new Dimension(480, 400));
		
		p1 = new JPanel();
		p1.setPreferredSize(new Dimension(480, 30));
		p1.setLayout(new FlowLayout(FlowLayout.LEFT,6,6));
	
		titolo = new JLabel();
		titolo.setText("RISULTATO CON ALGORITMO " + algoName);
		p1.add(titolo);
		p.add(p1);
		
		p2= new JPanel();
		p2.setPreferredSize(new Dimension(480, 100));  
		p2.setLayout( new GridLayout(2,1,6,6));	
		
		p2_1 = new JPanel(); 
		RefStlab = new JLabel("Reference String:");
		p2_1.add(RefStlab, BorderLayout.WEST);
		
		p2.add(p2_1, BorderLayout.WEST);
		
		refSt = new JTextField((input.length)*2);
		refSt.setEditable(false);
		for (int c = 0; c<input.length; c++)
		{
		stringa = stringa + input[c] + " ";
			}
		refSt.setText(stringa);	
		p2_1.add(refSt);
		
		p2.add(p2_1, BorderLayout.WEST);

		p2_2 = new JPanel(); 
		pflab = new JLabel("N. Page Fault:");
		p2_2.add(pflab);
		
		pf = new JTextField(3);
		pf.setEditable(false);
		p2_2.add(pf);
		
		p2.add(p2_2);
		
		p.add(p2);
		
		p3 = new JPanel();
		p3.setSize(470, 80);
		p3.setLayout(new FlowLayout(FlowLayout.CENTER, 6,6));
		p3.setBorder(new TitledBorder("Situazione dei Frame"));
		
		eseguiFirst();
 	    esegui();
 	    //creo la tabella
		vittime[0]=0;
		for (int y = 0; y<input.length; y++)
		{
			for (int j = 0; j<nframes; j++)
			{	
				vaso = dati[j][y];
				if (vaso !=(-1))
				{
					if (vittime[y]==j)
					{
					frameTab[j][y] = (new Integer(vaso) + " PF");
					}
					else 
					frameTab[j][y] = (new Integer(vaso));
				}
				else
				{
				frameTab[j][y] = "libero";	
				}	
			}
		}
		for (int i=0; i<input.length; i++)
		{
		cn = ("tempo" + Integer.toString(i));	
		columnNames[i] = cn ;
		}
		model = new DefaultTableModel( frameTab, columnNames);
		mvtab = new JTable(model);
		mvtab.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
	    mvtab.setPreferredScrollableViewportSize(new Dimension(460,80));
		mvtab.setRowHeight(15);
		mvtab.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		
		psp= new JScrollPane(mvtab);
		psp.setSize(new Dimension(460, 50));
			Dimension d= mvtab.getPreferredSize();
				int x=d.width;
				psp.getViewport().setViewPosition(new Point(x,0));	
		p3.add(psp);
		p.add(p3);
		
		pf.setText(Integer.toString(nPageFault));
				
		p4 = new JPanel();
		p4.setSize(new Dimension(480,50));
		p4.setLayout(new GridLayout(1,2,6,6));
		
		Start = new JButton("Home");
		Start.setToolTipText("Ritorna all'inserimento dei dati");
		p4.add(Start);
		Start.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                StartActionPerformed(evt);
            }
		});
		
		Esci = new JButton("Esci");
		Esci.setToolTipText("Uscita dal programma");
		 Esci.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                EsciActionPerformed(evt);
            }
        });
		p4.add(Esci);
		
		p.add(p4, BorderLayout.EAST);
		mvtab.updateUI();
		cnt.add(p);
		
				
}

/**
 *Metodi Action Performed.
 */
	private void EsciActionPerformed(ActionEvent evt) {
System.exit(0);
    }
    
    private void StartActionPerformed(ActionEvent evt) {
again = true;
    }
    

			
/**
 * Inizializza opportunamente le variabili.
 */     
    public void initAll()
    {
    	//init memoria virtuale  
  		MV = new MemoriaVirtuale(nframes); 
  	 	pmax = input[0];

		//individuo l'indice max per sapere quante sono le pagine   
  		for (int i = 1; i<(input.length-1);i++)
		  	{	
		  	if (input[i+1]>pmax)
		  	{pmax=input[i+1];
		  	}
  		}
   		npagine=pmax+1;
 		tlb = new TLB(npagine); //init tabella della pagine
 		int pagRef;
		pcorrente= new Page();
		}
/**
 * Esegue l'algoritmo scelto e ne visualizza il risultato.
 */	
	public void esegui()
	{   

	for (tp = 0; tp<(input.length); tp++)   //per ogni riferimento della stringa
 	{ 
 	MV.tempo = tp;
 	pagRef = input[tp];
 			
		//controllo nella tabella delle pagine se la pagina richiesta  gi caricata 	  
 	if (!(tlb.PageInMV(pagRef)))  
		{ 	
			nPageFault++;
			tlb.LoadPage(pagRef, tp); //carico la pagina e aggiorno la tabella
			pcorrente = tlb.getPage(pagRef);

			if (MV.full)          //se non ci sono frame liberi cerco la vittima con l'algoritmo scelto
				{
				if (algoritmo==1)
					  indexVic = MV.vittimaLRU();
				if (algoritmo==2)
					indexVic = MV.vittimaFIFO();
				if (algoritmo==3)
					indexVic = MV.vittimaLIFO();
				if (algoritmo==4)
					indexVic = MV.vittimaOPT(input);
				if (algoritmo==5)
					indexVic = MV.vittimaMFU();
				if (algoritmo==6)
					indexVic = MV.vittimaLFU();	
					
					vittime[tp]=MV.victimAt;
					tlb.UnloadedPage(indexVic);    //aggiornamento della pagina nella tabella delle pagine   
					MV.sostituisci(pcorrente);		//sostituzione della pagina vittima con la nuova
					
				}
			else 									//se ci sono frame liberi basta aggiungere la pagina
				{	
					vittime[tp]=firstLibero;
					MV.aggiungiP(pcorrente);
					firstLibero++;
			
				}
		}
		else 										//se la pagina  gi in memoria aggiorno i suoi parametri
			{	
				vittime[tp]=-1;
				tlb.LoadPage(pagRef, tp);
				MV.aggiornaCont(pagRef);
			
			
			}
			arrayMemo = new int[nframes];
			arrayMemo = MV.getMV();
			for (int k=0;k<nframes;k++)
			{
				dati[k][tp]=arrayMemo[k];
			}
			}

	}	
/**
 * Esegue il primo riferimento.
 */
public void eseguiFirst()
	{   

	MV.tempo = tp;
 	pagRef = input[tp];
  	
			nPageFault++;
					
			tlb.LoadPage(pagRef, tp); //carico la pagina e aggiorno la tabella
			pcorrente = tlb.getPage(pagRef);
			MV.aggiungiP(pcorrente);

			}
/**
 * Restituisce una variabile che indica se l'utente desidera ricominciare.
 */			
public boolean Ricomincia()
{     return again;
	}
	
	
}	


