/**
 * @(#)RisFrame.java
 * @author Claudia Rizzello
 * Classe della finestra relativa alla procedura con Risultato passo per passo.
 *
 */
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JTable.*;
import javax.swing.border.*;

public class StepFrame extends JFrame {
	
	private JPanel p;
	private JPanel p1;
	private JPanel p2;
	private JPanel p2_1;
	private JPanel p2_2;
	private JPanel p2_3;
	private JPanel p2_4;
	private JPanel p3;
	private JPanel p4;
	
	private JLabel titolo;
	private JLabel paglab;
	private JLabel tplab;
	private JLabel vicLab;
	private JLabel pflab;
	
	private JTextField tempo;
	private JTextField pagcall;
	private JTextField pf;
	private JTextField vic;
	
	private JScrollPane psp;
	private DefaultTableModel model;
	private JTable mvtab;
	
	private JButton Esci;
	private JButton Avanti;
	
	private int tp = 0;
	private int nframes;
	private int[] input;  
  	private TLB tlb;
  	private int nPageFault = 0;
  	private MemoriaVirtuale MV;
  	private int npagine;
  	private Page pcorrente;
  	private int indexVic = -1;	
  	private int pmax;	
  	private String mevi; 
	private String algoName = "";
	private int algoritmo;
	private int pagRef;
	private Object frameTab[][];
	private int[] sf; 
	private boolean again = false;	
	private int victimAt = -1;	
	private DefaultTableCellRenderer mcr;
	private int l = -1;	

/**
 * Costruttore.
 *@Param int[] ref, int nFrame, int alg, String alName.
 */
	public StepFrame(int[] ref, int nFrame, int alg, String alName) {
		
	   	
    	input = new int[ref.length];
		input = ref;
		nframes = nFrame;
		algoritmo = alg;
		algoName = alName;
		frameTab = new Object[nframes][1];
		sf = new int[nframes];
		mcr = new DefaultTableCellRenderer();
 	  	initAll();
		setSize(new Dimension(500, 400));
		Container cnt = getContentPane();
	
		p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT,6,6));
		p.setSize(new Dimension(480, 400));
		
		p1 = new JPanel();
		p.setPreferredSize(new Dimension(480, 30));
		p.setLayout(new FlowLayout(FlowLayout.LEFT,6,6));
	
		titolo = new JLabel();
		titolo.setText("STEP BY STEP CON ALGORITMO " + algoName);
		p1.add(titolo, "center");
		p.add(p1);
		
		p2= new JPanel();
		p2.setPreferredSize(new Dimension(480, 100));  
		p2.setLayout( new GridLayout(2,2,6,6));	
		
		p2_1 = new JPanel(); 
		tplab = new JLabel("Tempo:      ");
		p2_1.add(tplab);
		
		tempo = new JTextField(6);
		tempo.setEditable(false);
		p2_1.add(tempo);
		
		p2.add(p2_1);
		
		p2_2 = new JPanel(); 
		paglab = new JLabel("Pagina entrante:");
		p2_2.add(paglab);
		
		pagcall = new JTextField(6);
		pagcall.setEditable(false);
		p2_2.add(pagcall);			
		p2.add(p2_2);
		
		p2_3 = new JPanel(); 
		pflab = new JLabel("N. Page Fault:");
		p2_3.add(pflab);
		
		pf = new JTextField(6);
		pf.setEditable(false);
		p2_3.add(pf);
		
		p2.add(p2_3);
		
		p2_4 = new JPanel();
		vicLab = new JLabel("Pagina uscente:");
		p2_4.add(vicLab);
		
		vic = new JTextField(6);
		vic.setEditable(false);
		p2_4.add(vic);
		p2.add(p2_4);
		
		p.add(p2);
		
		p3 = new JPanel();
		p3.setSize(470, 80);
		p3.setLayout(new FlowLayout(FlowLayout.CENTER, 6,6));
		p3.setBorder(new TitledBorder("Situazione dei Frame"));
		
		esegui();
 	    
 	    //creo la tabella
		sf = MV.getMV();
		for (int y = 0;y<sf.length;y++)
		{
		int p = sf[y];
		if (p!=(-1))
		{
		frameTab[y][0] = (new Integer(p) + " PF");
		}
		else
		{ 
		frameTab[y][0] = "libero";	
		}
		}
		String[] columnNames = {"Tempo 0"};
		model = new DefaultTableModel( frameTab, columnNames);
		mvtab = new JTable(model);
		mvtab.putClientProperty("terminateEditOnFocusLost", Boolean.TRUE);
		mvtab.setPreferredScrollableViewportSize(new Dimension(450,80));
		mvtab.setRowHeight(15);
		mvtab.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		mvtab.getColumnModel().getColumn(0).setCellRenderer(mcr);
		psp= new JScrollPane(mvtab);
		psp.setSize(new Dimension(450, 50));
		p3.add(psp);
		p.add(p3);
				
		p4 = new JPanel();
		p4.setSize(new Dimension(480,50));
		p4.setLayout(new GridLayout(1,2,6,6));
		
		Avanti = new JButton("Avanti");
		Avanti.setToolTipText("Passo successivo");
		p4.add(Avanti);
		Avanti.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                AvantiActionPerformed(evt);
            }
		});
		
		Esci = new JButton("Esci");
		 Esci.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                EsciActionPerformed(evt);
            }
        });
		p4.add(Esci);
		
		p.add(p4, BorderLayout.EAST);
		
		cnt.add(p);
				
}

/**
 *Metodi Action Performed
 */
	private void EsciActionPerformed(ActionEvent evt) {
		System.exit(0);
    }
    private void AvantiActionPerformed(ActionEvent evt) {
    	Thread t = new Thread(){
 	     public void run(){
 	     	Avanti.setEnabled(false);
 	     	if ((Avanti.getText()).equals("Home"))
 	     	{
 	     		again=true;
 	     	}
    if (tp<(input.length-1))
    { 
                Avanti.setEnabled(false);
    			tp++;
    			MV.tempo=tp;
    			esegui();
    			
    			sf = MV.getMV();			
				String header = ("tempo" + (Integer.toString(tp)));
 				String[] values = new String[nframes];
 
				for (int j = 0; j < nframes; j++)
				{
					if (sf[j]!=(-1))
					{
						if (j==victimAt){
						values[j] = "" + sf[j] + "PF";
					}
					else
						values[j] = "" + sf[j];
					}
					else values[j]= "libero";
									
				}
 				
				model.addColumn( header, values );
				mvtab.requestFocusInWindow();
				Dimension d= mvtab.getPreferredSize();
				int x=d.width;
				psp.getViewport().setViewPosition(new Point(x,0));	
				Avanti.setEnabled(true);
				if (tp==(input.length-1))
				{
					Avanti.setText("Home");
					Avanti.setToolTipText("Nuovo inserimento");
				}	
					}
			p3.updateUI();		
			Avanti.setEnabled(true);		
    		}
    		};
				t.start();
    		}
			
/**
 *Inizializza opportunamente le variabili.
 */	 
    public void initAll()
    {
    	//init memoria virtuale  
  		MV = new MemoriaVirtuale(nframes); 
  	 	pmax = input[0];

		//individuo l'indice max per sapere quante sono le pagine   
  		for (int i = 1; i<(input.length-1);i++)
		  	{	
		  	if (input[i+1]>pmax)
		  	{pmax=input[i+1];
		  	}
  		}
   		npagine=pmax+1;
 		tlb = new TLB(npagine); //init tabella della pagine
 		int pagRef;
		pcorrente= new Page();
		}
/**
 *Esegue un passo dell'algoritmo scelto
 */
	public void esegui()
	{   
		pagRef = input[tp];
		tempo.setText(Integer.toString(tp));	
		pagcall.setText(Integer.toString(pagRef));
		
		//controllo nella tabella delle pagine se la pagina richiesta  gi caricata 	  
 	if (!(tlb.PageInMV(pagRef)))  
		{ 	
			nPageFault++;
			pf.setText(Integer.toString(nPageFault));
			
			tlb.LoadPage(pagRef, tp); //carico la pagina e aggiorno la tabella
			pcorrente = tlb.getPage(pagRef);

			if (MV.full)          //se non ci sono frame liberi cerco la vittima con l'algoritmo scelto
				{
				if (algoritmo==1)
					  indexVic = MV.vittimaLRU();
				if (algoritmo==2)
					indexVic = MV.vittimaFIFO();
				if (algoritmo==3)
					indexVic = MV.vittimaLIFO();
				if (algoritmo==4)
					indexVic = MV.vittimaOPT(input);
				if (algoritmo==5)
					indexVic = MV.vittimaMFU();
				if (algoritmo==6)
					indexVic = MV.vittimaLFU();	
					
					victimAt = MV.victimAt;
					vic.setText(Integer.toString(indexVic));				  
					tlb.UnloadedPage(indexVic);    //aggiornamento della pagina nella tabella delle pagine   
					MV.sostituisci(pcorrente);		//sostituzione della pagina vittima con la nuova
				}
			else 									//se ci sono frame liberi basta aggiungere la pagina
				{
					MV.aggiungiP(pcorrente);
					vic.setText("nessuna");
					l++;
					victimAt=l;
				}
		}
		else 										//se la pagina  gi in memoria aggiorno i suoi parametri
			{	victimAt=-1;
				tlb.LoadPage(pagRef, tp);
				MV.aggiornaCont(pagRef);
				vic.setText("nessuna");
			
			}
			}
/**
 *Restituisce una variabile che indica se l'utente intende ricominciare.
 */			
	public boolean Ricomincia()
{     return again;
	}
	
}	

			
		



